---
title: SourceBuffer.trackDefaults
slug: Web/API/SourceBuffer/trackDefaults
tags:
  - API
  - Audio
  - Experimental
  - MSE
  - Media Source Extensions
  - Property
  - Reference
  - SourceBuffer
  - Video
  - trackDefaults
---
<div>{{APIRef("Media Source Extensions")}}{{obsolete_header}}</div>

<p>The <code><strong>trackDefaults</strong></code> property of the {{domxref("SourceBuffer")}} interface specifies the default values to use if kind, label, and/or language information is not available in the <a href="https://w3c.github.io/media-source/#init-segment">initialization segment</a> of the media to be appended to the <code>SourceBuffer</code>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>myTrackDefaults</em> = <em>sourceBuffer</em>.trackDefaults;

<em>sourceBuffer</em>.trackDefaults = <em>myTrackDefaultList</em>;
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("TrackDefaultList")}} object.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>The following exceptions may be thrown when setting a new value for this property.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Explanation</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>InvalidStateError</code></td>
   <td>One or more of the {{domxref("SourceBuffer")}} objects in {{domxref("MediaSource.sourceBuffers")}} are being updated (i.e. their {{domxref("SourceBuffer.updating")}} property is currently <code>true</code>), or this <code>SourceBuffer</code> has been removed from the {{domxref("MediaSource")}}.</td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>TBD</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.SourceBuffer.trackDefaults")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("MediaSource")}}</li>
 <li>{{domxref("SourceBufferList")}}</li>
</ul>
